/***************************************************************************
 *   Copyright (C) 2005 by Peter Donis                                     *
 *   peterdonis@alum.mit.edu                                               *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef _KIDSERVER_H_
#define _KIDSERVER_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kmainwindow.h>
#include <kprocess.h>
#include <kaboutapplication.h>
#include <kaboutdata.h>

#include "kidserverwidget.h"

/**
 * @short Application Main Window
 * @author Peter Donis <peterdonis@alum.mit.edu>
 * @version 0.4.1
 */
class kidserver : public KMainWindow
{
  Q_OBJECT
  public:
    /** constructor */
    kidserver(const KAboutData *aboutdata, const char *url);
    /** destructor */
    virtual ~kidserver();
  public slots:
    /** slots to accept signals from widget */
    void widget_clickedAbout();
    void widget_clickedGo();
    void widget_clickedStop();
    void widget_clickedQuit();
    /** slots to accept signals from idserver */
    void idserver_output(KProcess *, char *buffer, int);
    void idserver_exited(KProcess *);
  private:
    /** user interface widget -- occupies client area of this window */
    kidserverWidget *widget;
    /** about dialog box */
    KAboutApplication *aboutBox;
    /** idserver command-line utility process */
    KProcess * idserver;
    /** flag to indicate that idserver is running */
    bool idserver_running;
    /** does the actual work of calling idserver with the right arguments */
    void go_url();
    /** stops idserver when user aborts */
    void stop_url();
};

#endif // _KIDSERVER_H_
